<template>
  <app-form title="Edit Card" :open="open" @close="cancelEdit">
    <form-group labelFor="form-edit-card-name" label="Card Name">
      <form-input
        id="form-edit-card-name"
        v-model="name"
        placeholder="Please Provide the name of the card..."
      ></form-input>
    </form-group>
    <form-group labelFor="form-edit-card-description" label="Description">
      <form-input
        id="form-edit-card-description"
        v-model="description"
        type="textarea"
        placeholder="Please Provide the description of the card..."
      ></form-input>
    </form-group>
    <form-group labelFor="form-edit-card-date" label="Due Date">
      <form-input
        id="form-edit-card-date"
        v-model="date"
        type="date"
        placeholder="Please Provide the date of the card..."
      ></form-input>
    </form-group>
    <todo-list :cardId="card.id || 'dummyId'" />
    <div>
      <h5 class="text-muted pt-2 pb-1">Danger Zone</h5>
      <button
        @click="deleteCard"
        type="button"
        class="btn btn-danger pt-1 pb-2"
      >
        Delete Card
      </button>
    </div>
    <template v-slot:footer>
      <button @click="editCard" type="button" class="btn btn-primary">
        save
      </button>
      <button @click="cancelEdit" type="button" class="btn btn-light">
        Cancel
      </button>
    </template>
  </app-form>
</template>

<script lang="ts">
import { Card } from "@/core/database";
import { defineComponent, PropType } from "vue";
import AppForm from "../components/Form.vue";
import FormGroup from "../components/FormGroup.vue";
import FormInput from "../components/FormInput.vue";
import TodoList from "@/components/TodoList.vue";

export default defineComponent({
  components: { AppForm, FormGroup, FormInput, TodoList },
  emits: ["edit", "cancel", "delete"],
  props: {
    open: {
      type: Boolean,
      required: true,
    },
    card: {
      type: Object as PropType<Card>,
      required: true,
    },
  },
  watch: {
    card: {
      deep: true,
      handler() {
        this.name = this.card.name;
        this.description = this.card.description;
        this.date = this.card.date;
      },
    },
  },
  data() {
    return {
      name: "",
      description: "",
      date: new Date(),
    };
  },
  methods: {
    editCard() {
      const editedCard = new Card(
        this.card.id,
        this.name,
        this.card.listId,
        this.description,
        this.date
      );
      this.$emit("edit", editedCard);
      this.cancelEdit();
    },
    cancelEdit() {
      this.$emit("cancel");
    },
    deleteCard() {
      this.$emit("delete", this.card);
      this.cancelEdit();
    },
  },
});
</script>
